devtools: split meson build helper
[dpdk.git] / devtools / test-meson-builds.sh
1 #! /bin/sh -e
2 # SPDX-License-Identifier: BSD-3-Clause
3 # Copyright(c) 2018 Intel Corporation
4
5 # Run meson to auto-configure the various builds.
6 # * all builds get put in a directory whose name starts with "build-"
7 # * if a build-directory already exists we assume it was properly configured
8 # Run ninja after configuration is done.
9
10 # set pipefail option if possible
11 PIPEFAIL=""
12 set -o | grep -q pipefail && set -o pipefail && PIPEFAIL=1
13
14 srcdir=$(dirname $(readlink -f $0))/..
15 . $srcdir/devtools/load-devel-config
16
17 MESON=${MESON:-meson}
18 use_shared="--default-library=shared"
19 builds_dir=${DPDK_BUILD_TEST_DIR:-.}
20
21 if command -v gmake >/dev/null 2>&1 ; then
22         MAKE=gmake
23 else
24         MAKE=make
25 fi
26 if command -v ninja >/dev/null 2>&1 ; then
27         ninja_cmd=ninja
28 elif command -v ninja-build >/dev/null 2>&1 ; then
29         ninja_cmd=ninja-build
30 else
31         echo "ERROR: ninja is not found" >&2
32         exit 1
33 fi
34 if command -v ccache >/dev/null 2>&1 ; then
35         CCACHE=ccache
36 else
37         CCACHE=
38 fi
39
40 default_path=$PATH
41 default_pkgpath=$PKG_CONFIG_PATH
42 default_cppflags=$CPPFLAGS
43 default_cflags=$CFLAGS
44 default_ldflags=$LDFLAGS
45
46 load_env () # <target compiler>
47 {
48         targetcc=$1
49         export PATH=$default_path
50         export PKG_CONFIG_PATH=$default_pkgpath
51         export CPPFLAGS=$default_cppflags
52         export CFLAGS=$default_cflags
53         export LDFLAGS=$default_ldflags
54         unset DPDK_MESON_OPTIONS
55         command -v $targetcc >/dev/null 2>&1 || return 1
56         DPDK_TARGET=$($targetcc -v 2>&1 | sed -n 's,^Target: ,,p')
57         . $srcdir/devtools/load-devel-config
58 }
59
60 config () # <dir> <builddir> <meson options>
61 {
62         dir=$1
63         shift
64         builddir=$1
65         shift
66         if [ -f "$builddir/build.ninja" ] ; then
67                 return
68         fi
69         options="--werror -Dexamples=all"
70         for option in $DPDK_MESON_OPTIONS ; do
71                 options="$options -D$option"
72         done
73         options="$options $*"
74         echo "$MESON $options $dir $builddir"
75         $MESON $options $dir $builddir
76 }
77
78 compile () # <builddir>
79 {
80         builddir=$1
81         if [ -n "$TEST_MESON_BUILD_VERY_VERBOSE" ] ; then
82                 # for full output from ninja use "-v"
83                 echo "$ninja_cmd -v -C $builddir"
84                 $ninja_cmd -v -C $builddir
85         elif [ -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
86                 # for keeping the history of short cmds, pipe through cat
87                 echo "$ninja_cmd -C $builddir | cat"
88                 $ninja_cmd -C $builddir | cat
89         else
90                 echo "$ninja_cmd -C $builddir"
91                 $ninja_cmd -C $builddir
92         fi
93 }
94
95 build () # <directory> <target compiler> <meson options>
96 {
97         targetdir=$1
98         shift
99         targetcc=$1
100         shift
101         # skip build if compiler not available
102         command -v ${CC##* } >/dev/null 2>&1 || return 0
103         load_env $targetcc || return 0
104         config $srcdir $builds_dir/$targetdir $*
105         compile $builds_dir/$targetdir
106 }
107
108 if [ "$1" = "-vv" ] ; then
109         TEST_MESON_BUILD_VERY_VERBOSE=1
110 elif [ "$1" = "-v" ] ; then
111         TEST_MESON_BUILD_VERBOSE=1
112 fi
113 # we can't use plain verbose when we don't have pipefail option so up-level
114 if [ -z "$PIPEFAIL" -a -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
115         echo "# Missing pipefail shell option, changing VERBOSE to VERY_VERBOSE"
116         TEST_MESON_BUILD_VERY_VERBOSE=1
117 fi
118
119 # shared and static linked builds with gcc and clang
120 for c in gcc clang ; do
121         command -v $c >/dev/null 2>&1 || continue
122         for s in static shared ; do
123                 export CC="$CCACHE $c"
124                 build build-$c-$s $c --default-library=$s
125                 unset CC
126         done
127 done
128
129 # test compilation with minimal x86 instruction set
130 # Set the install path for libraries to "lib" explicitly to prevent problems
131 # with pkg-config prefixes if installed in "lib/x86_64-linux-gnu" later.
132 default_machine='nehalem'
133 ok=$(cc -march=$default_machine -E - < /dev/null > /dev/null 2>&1 || echo false)
134 if [ "$ok" = "false" ] ; then
135         default_machine='corei7'
136 fi
137 build build-x86-default cc -Dlibdir=lib -Dmachine=$default_machine $use_shared
138
139 c=aarch64-linux-gnu-gcc
140 # generic armv8a with clang as host compiler
141 export CC="clang"
142 build build-arm64-host-clang $c $use_shared \
143         --cross-file $srcdir/config/arm/arm64_armv8_linux_gcc
144 unset CC
145 # all gcc/arm configurations
146 for f in $srcdir/config/arm/arm64_[bdo]*gcc ; do
147         export CC="$CCACHE gcc"
148         build build-$(basename $f | tr '_' '-' | cut -d'-' -f-2) $c \
149                 $use_shared --cross-file $f
150         unset CC
151 done
152
153 # Test installation of the x86-default target, to be used for checking
154 # the sample apps build using the pkg-config file for cflags and libs
155 build_path=$(readlink -f $builds_dir/build-x86-default)
156 export DESTDIR=$build_path/install-root
157 $ninja_cmd -C $build_path install
158
159 load_env cc
160 pc_file=$(find $DESTDIR -name libdpdk.pc)
161 export PKG_CONFIG_PATH=$(dirname $pc_file):$PKG_CONFIG_PATH
162
163 # if pkg-config defines the necessary flags, test building some examples
164 if pkg-config --define-prefix libdpdk >/dev/null 2>&1; then
165         export PKGCONF="pkg-config --define-prefix"
166         for example in cmdline helloworld l2fwd l3fwd skeleton timer; do
167                 echo "## Building $example"
168                 $MAKE -C $DESTDIR/usr/local/share/dpdk/examples/$example clean all
169         done
170 fi